       program hcl
C* hierarchical clustering
C* Michael Fuchs 04/2000 
c* fortran 77
c* Matrix 200 Objekte * 1000 Variablen
c* 
C* proximities - mdist
c*              1 = Quadrierte Euklidische Distanz
c*              2 = Euklidische Distanz
c*              3 = Chi-Quadrat
c*              4 = Tanimoto Koeffizient
c*              5 = Q-Korrelationskoeffizient
c* cluster - caggl
c*              1 = Single Linkage
c*              2 = Complete Linkage
       implicit none
       character*255 inFile,outFile,outFile1,outFile2,args,result
       character str*50
       integer  mdist,caggl,numObj,numVar,ierr,ierr1
       read (5,'(A)') args
       read (args(1:index(args, ' ')),'(a255)') inFile
       read (args(index(args,' '):255),*) numObj,numVar,mdist,caggl
       ierr=0
       call proximities(inFile,numObj,numVar,mdist,outFile,ierr)
       if (ierr.eq.-1) 
     *  result=inFile(1:index(inFile,' '))//' existiert nicht'
       if (ierr.eq.-2) 
     *  result='temporary '
     *//outFile(1:index(outFile,' '))//' existiert bereits'
       if (ierr.eq.-3)
     *   result= 'Ein Rechenfehler ist aufgetreten!'
       if (ierr.eq.-4)
     *   result=inFile(1:index(inFile,' '))//' enthlt Zeichenketten'           
       if (ierr.eq.0) then 
          call cluster
     *    (outFile,numObj,mdist,caggl,outFile1,outFile2,ierr1)
          if (ierr1.eq.0) then
           result=outFile1(1:index(outFile1,' '))
     *//outFile2(1:index(outFile2,' '))
            if (mdist.eq.1) str='Quadrierte Euklidische Distanz'
            if (mdist.eq.2) str='Euklidische Distanz'
            if (mdist.eq.3) str='Chi-Quadrat'
            if (mdist.eq.4) str='Tanimoto Koeffizient'
            if (mdist.eq.5) str='Q-Korrelationskoeffizient'
            if (caggl.eq.1) str=str(1:31)//'Single Linkage'
            if (caggl.eq.2) str=str(1:31)//'Complete Linkage'
            str='*'//str
            write(*,'(a50)') str
            write(*,'(a1,i4,a8,a1,i4,a9)') 
     *        '*',numObj,' Objekte',',',numVar,' Variable'
           endif
           if (ierr1.eq.-1)
     *      result=outFile(1:index(outFile,' '))//' existiert nicht'
           if (ierr1.eq.-2)
     *     result=outFile1(1:index(outFile1,' '))//' existiert bereits'
           if (ierr1.eq.-3)
     *     result=outFile2(1:index(outFile2,' '))//' existiert bereits'
           if (ierr1.eq.-4)
     *     result= 'Ein Rechenfehler ist aufgetreten! Distanzen zu gro'
        endif
       write (0,'(A)') result
100    continue
       end

c*****************************************************************
c*****************************************************************

       subroutine proximities(inFile,numObj,numVar,mdist,outFile,ierr)

       implicit none
       integer maxVariable
c* Maximum der Variablen 
       parameter(maxVariable=1000)

       character*255 inFile,outFile
       integer numObj,numVar,mdist,i,j,k,l,m,ierr
       real objekt1(maxVariable),objekt2(maxVariable)
       real distanz12,d12  

c*     numObj - Anzahl der Faelle
c*     numVar - Anzahl der Variablen
c*     mdist  - Art des Abstandsmasses 
c*              1 = Quadrierte Euklidische Distanz
c*              2 = Euklidische Distanz
c*              3 = Chi-Quadrat
c*              4 = Tanimoto Koeffizient
c*              5 = Q-Korrelationskoeffizient

       outFile=inFile(1:index(inFile,'.'))//'proximities'

       open(21,status='OLD',file=inFile,err=100)
       open(22,status='NEW',file=outFile,err=110)

       l=1
       do 1 i=l,numObj
          read (21,*,ERR=90) (objekt1(m),m=1,numVar)
          do 2 j=i+1,numObj
            read (21,*,ERR=90) (objekt2(m),m=1,numVar)

c           ** call function distanz12 **
            d12=distanz12(objekt1,objekt2,maxVariable,numVar,mdist)           
            if (d12.eq.-999999.999999) then
                close(22,status='DELETE')
                ierr=-3
                goto 120
             endif
            write(22,'(f20.6,2i6)') d12,l,j
2          continue
          l=l+1
          do 3 k=l,numObj
            backspace 21
3          continue
1       continue

       close(21)
       close(22)
       goto 120
90     continue
       close(21)
       close(22,status='DELETE')
       ierr=-4
       goto 120
100    continue
       ierr=-1
       goto 120
110    continue
       ierr=-2
120    continue

       end

c---------------------------------------------------------------

       real function distanz12 (obj1,obj2,maxV,nV,d)

       implicit none
       integer maxVariable
c* Maximum der Variablen 
       parameter(maxVariable=1000)

       integer maxV,nV,d,i,a,b,c
       real obj1(maxV),obj2(maxV),fe1(maxV),fe2(maxV)
       real dist12(maxVariable)
       real mean1,mean2,quadrat1(maxVariable),quadrat2(maxVariable)
       real sd12,sq1,sq2,z_sum(2),s_sum(maxV),p_sum,chisquare

        distanz12=0.
        mean1=0.
        mean2=0.
        sd12=0.
        sq1=0.
        sq2=0.
        a=0
        b=0
        c=0
        chisquare=0.
        z_sum(1)=0.
        z_sum(2)=0.
c*  Distanzmass Euklid 
        if ((d.eq.1) .or. (d.eq.2)) then
            do 1 i=1,nV
              dist12(i)=obj1(i)-obj2(i)
              dist12(i)=dist12(i)*dist12(i)
1            continue

            do 2 i=1,nV
              distanz12=distanz12+dist12(i)
2             continue

            if (d.eq.2) then
                distanz12=sqrt(distanz12)
            endif

c*  Distanzmass Tanimoto-Koeffizient
        else if (d.eq.4) then
          do 5 i=1,nV
            if ((int(obj1(i)).eq.1).and.(int(obj2(i)).eq.1)) then 
             a=a+1
            else if ((int(obj1(i)).eq.1).and.(int(obj2(i)).eq.0)) then 
             b=b+1
            else if ((int(obj1(i)).le.0).and.(int(obj2(i)).eq.1)) then 
             c=c+1
            endif
5          continue
            if(real(a+b+c).le.2E-06) then
               write(*,*)'* Variablen mssen binr codiert sein!'
               write(*,*)'*                ODER'
               write(*,*)
     * '* mindestens eine Variable mit Inhalt 1 mu vorhanden sein!'
               distanz12=-999999.999999
             else
               distanz12=real(a)/(real(a+b+c))
             endif

c*  Distanzmass  Q-Korrelationskoeffizient
        else if (d.eq.5) then
             do 6 i=1,nV
                mean1=mean1+(obj1(i))/real(nV)
                mean2=mean2+(obj2(i))/real(nV)
6             continue
             do 7 i=1,nV
               dist12(i)=(obj1(i)-mean1)*(obj2(i)-mean2)
               quadrat1(i)=(obj1(i)-mean1)*(obj1(i)-mean1)
               quadrat2(i)=(obj2(i)-mean2)*(obj2(i)-mean2)
7             continue
             do 8 i=1,nV
                sd12=sd12+dist12(i)
                sq1=sq1+quadrat1(i)
                sq2=sq2+quadrat2(i)
8             continue
             distanz12=sd12/sqrt(sq1*sq2)
c*  Distanzmass  Chi-Quadrat
        else if (d.eq.3) then
             do 10 i=1,nV
                 z_sum(1)=z_sum(1)+obj1(i)
                 z_sum(2)=z_sum(2)+obj2(i)
                 s_sum(i)=obj1(i)+obj2(i)
10            continue
              p_sum=z_sum(1)+z_sum(2)
            do 11 i=1,nV
                 fe1(i)=(s_sum(i)*z_sum(1))/p_sum
                 fe2(i)=(s_sum(i)*z_sum(2))/p_sum
11          continue
            do 12 i=1,nV
             if (fe1(i).ne.0) chisquare=chisquare+
     *        (((obj1(i)-fe1(i))*(obj1(i)-fe1(i)))/fe1(i))
             if (fe2(i).ne.0) chisquare=chisquare+
     *        (((obj2(i)-fe2(i))*(obj2(i)-fe2(i)))/fe2(i))
12          continue
            distanz12=sqrt(abs(chisquare))
        endif
       end

c*****************************************************************
c*****************************************************************

       subroutine cluster
     *   (proxFile,nO,mdist,caggl,clulFile,errFile,ierr)

       implicit none
       character proxFile*255,clulFile*255,errFile*255,format*8
       integer nO,nD,i,j,MaxDis,next,pos_minimum,pos_maximum,last,ierr
       integer clusterloesung(200),merkf(200),stage,k,mdist,caggl
       real fehlerquadrat(200)
C*  maximale Groesse der Distanzmatrix 
       parameter(MaxDis=19900)
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer flag
       end structure

       record /einproximity/proximities(MaxDis)

c*     caggl - Art der Distanzberechnung beim Clustern
c*              1 = Single Linkage
c*              2 = Comlete Linkage

       format='(    i4)'
       write (format(2:5),'(i4)') nO
       clulFile=proxFile(1:index(proxFile,'.'))//'cluster'
       errFile=proxFile(1:index(proxFile,'.'))//'error'
        nD=nO*(nO-1)/2
        open(22,status='OLD',file=proxFile,err=110)
        open(23,status='NEW',file=clulFile,err=120)
        open(24,status='NEW',file=errFile,err=130)
        stage=1
        do 1 i=1,nD
          read (22,'(f20.6,2i6)',err=135) proximities(i).distanz,
     *     proximities(i).case1,proximities(i).case2
1         continue
        close (22,status='DELETE')

        do 2 k=1,nO-1
         if (mdist.le.3) next=pos_minimum(proximities,nD)
         if (mdist.gt.3) next=pos_maximum(proximities,nD)
         fehlerquadrat(stage)=proximities(next).distanz
         do 5 i=1,nO
           if (i.eq.proximities(next).case2)then
             clusterloesung(i)=proximities(next).case1
             merkf(i)=proximities(next).case1
             last=proximities(next).case2
            else
                  clusterloesung(i)=i
                  if(merkf(i).gt.0) then
                    clusterloesung(i)=merkf(i)
                   endif
                  if (last.eq.clusterloesung(i)) then
                     merkf(i)=proximities(next).case1
                     clusterloesung(i)=merkf(i)
                    endif
            endif
5          continue
           write(23,'(a4,i6)') 'CLUL',(nO-stage)
           write(23,format)(clusterloesung(j),j=1,nO)
           write(24,'(i4,a1,f20.6)') 
     *     (nO-stage),',',fehlerquadrat(stage)

           call new_proximities(proximities,nO,nD,caggl,next) 

           stage=stage+1
2        continue
        close (23)
        close (24)
       goto 140
110     continue
        ierr=-1
        goto 140
120     continue
        ierr=-2
        close (22,status='DELETE')
        goto 140
130     continue
        ierr=-3
        close (22,status='DELETE')
        close (23,status='DELETE')
        goto 140
135     continue
        ierr=-4
        close (22,status='DELETE')
        close (23,status='DELETE')
        close (24,status='DELETE')
140     continue
       end

c---------------------------------------------------------------

       integer function pos_minimum(proximities,nrD)

       implicit none
       real minimum
       integer nrD,i,MaxDis
C*  maximale Groesse der Distanzmatrix 
       parameter(MaxDis=19900)
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer flag
       end structure

       record /einproximity/proximities(MaxDis)
       minimum=999999999999999.
       do 1 i=1,nrD
          if (proximities(i).flag.ne.-1) then
           if ((proximities(i).distanz).lt.minimum) then
              minimum=proximities(i).distanz
              pos_minimum=i
            endif
           endif
1      continue
       end
c---------------------------------------------------------------

       integer function pos_maximum(proximities,nrD)

       implicit none
       real maximum
       integer nrD,i,MaxDis
C*  maximale Groesse der Distanzmatrix 
       parameter(MaxDis=19900)
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer flag
       end structure

       record /einproximity/proximities(MaxDis)
       maximum=-999999999999999.
       do 1 i=1,nrD
          if (proximities(i).flag.ne.-1) then
           if ((proximities(i).distanz).gt.maximum) then
              maximum=proximities(i).distanz
              pos_maximum=i
            endif
           endif
1      continue
       end
c---------------------------------------------------------------

       subroutine new_proximities(proximities,nrO,nrD,caggl,next) 

       implicit none
       real newdistanz
       integer nrD,nrO,i,j,MaxDis,next,merk1,merk2,caggl,pos
C*  maximale Groesse der Distanzmatrix 
       parameter(MaxDis=19900)
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer flag
       end structure

       record /einproximity/proximities(MaxDis)

       merk1=0
       merk2=0
       pos=1
       do 1 i=1,nrO
         do 2 j=pos,nrD
           if (proximities(j).flag.ne.-1) then
            if ((i.ne.proximities(next).case1).and.
     *         (i.ne.proximities(next).case2)) then
               if (((proximities(next).case1).eq.
     *             (proximities(j).case1)).or.
     *             ((proximities(next).case1).eq.
     *             (proximities(j).case2))) then
                      if (((proximities(j).case1).eq.i).or.
     *                   ((proximities(j).case2).eq.i))merk1=j
               else if (((proximities(next).case2).eq.
     *             (proximities(j).case1)).or.
     *             ((proximities(next).case2).eq.
     *             (proximities(j).case2))) then
                      if (((proximities(j).case1).eq.i).or.
     *                   ((proximities(j).case2).eq.i))merk2=j

                endif
             endif
            endif
C* innere Schleife verlassen, wenn Parnter gefunden
              if ((merk1.gt.0).and.(merk2.gt.0)) goto 5
2           continue
5           continue
           if ((proximities(merk1).flag.ne.-1).and.
     *         (proximities(merk2).flag.ne.-1)) then
            if ((i.ne.proximities(next).case1).and.
     *         (i.ne.proximities(next).case2)) then


c* Single-Linkage*
                  if(caggl.eq.1) then  
                     newdistanz=
     *               (proximities(merk1).distanz+
     *               proximities(merk2).distanz-
     *               abs(proximities(merk1).distanz-
     *               proximities(merk2).distanz))/2.
c* Complete-Linkage*
                  else if (caggl.eq.2) then 
                     newdistanz=
     *               (proximities(merk1).distanz+
     *               proximities(merk2).distanz+
     *               abs(proximities(merk1).distanz-
     *               proximities(merk2).distanz))/2.
                  endif

                proximities(merk1).distanz=newdistanz
                proximities(merk2).flag=-1
                proximities(next).flag=-1
             endif
            endif
          pos=merk1
          merk1=0
          merk2=0 
1       continue
        end
