       program mds
C* Zweidimensionale Skalierung
C* Algorithmus von Kruskal
C* Michael Fuchs 06/1999 
c* fortran 77
c* Matrix 1000 Objekte * 1000 Variablen
c* 
C* proximities - mdist
c*              1 = Quadrierte Euklidische Distanz
c*              2 = Euklidische Distanz
c*              3 = Chi-Quadrat
c*              4 = Tanimoto Koeffizient
c*              5 = Q-Korrelationskoeffizient

       implicit none
       character*255 inFile,outFile,args,result,kfile,dfile
       character cstress*8,cit*6
       integer mdist,numObj,numVar,it,ierr,ierr1
       real stress,alpha
       read (5,'(A)') args
       read (args(1:index(args, ' ')),'(a255)') inFile
       read (args(index(args,' '):255),*) numObj,numVar,mdist,alpha
       ierr=0
       ierr1=0
       call proximities(inFile,numObj,numVar,mdist,outFile,ierr)
       if (ierr.eq.-1) 
     *  result=inFile(1:index(inFile,' '))//' existiert nicht'
       if (ierr.eq.-2) 
     *  result='temporary '
     *//outFile(1:index(outFile,' '))//' existiert bereits'
       if (ierr.eq.-3)
     *   result= 'Ein Rechenfehler ist aufgetreten!'
       if (ierr.eq.-4)
     *   result=inFile(1:index(inFile,' '))//' enthlt Zeichenketten' 
       if (ierr.eq.0) then 
         call ranking
     *     (outFile,numObj,mdist,kfile,dfile,alpha,stress,it,ierr1)
         if (ierr1.eq.0) then
           write (cstress,'(f8.6)') stress
           write (cit,'(i6)') it       
           result=
     *       kfile(1:index(kfile,' '))//dfile(1:index(dfile,' '))
     *       //cstress//cit
          endif
         if (ierr1.eq.-1)
     *      result=outFile(1:index(outFile,' '))//' existiert nicht'
         if (ierr1.eq.-2)
     *      result=kfile(1:index(kfile,' '))//' existiert bereits'
         if (ierr1.eq.-3)
     *      result=dfile(1:index(dfile,' '))//' existiert bereits'
         if (ierr1.eq.-4)
     *      result='Ein Rechenfehler ist aufgetreten! Distanzen zu gro'
        endif
       write (0,'(A)') result
100    continue
       end

c*****************************************************************

       subroutine proximities(inFile,numObj,numVar,mdist,outFile,ierr)

       implicit none
       integer maxVariable
c* Maximum der Variablen 
       parameter(maxVariable=1000)

       character*255 inFile,outFile
       integer numObj,numVar,mdist,i,j,k,l,m,ierr
       real objekt1(maxVariable),objekt2(maxVariable)
       real distanz12,d12  

c*     numObj - Anzahl der Faelle
c*     numVar - Anzahl der Variablen
c*     mdist  - Art des Abstandsmasses 
c*              1 = Quadrierte Euklidische Distanz
c*              2 = Euklidische Distanz
c*              3 = Tanimoto Koeffizient
c*              4 = Q-Korrelationskoeffizient
c*     Michael Fuchs 04/1998

       outFile=inFile(1:index(inFile,'.'))//'proximities'

       open(21,status='OLD',file=inFile,err=100)
       open(22,status='NEW',file=outFile,err=110)

       l=1
       do 1 i=l,numObj
          read (21,*,ERR=90) (objekt1(m),m=1,numVar)
          do 2 j=i+1,numObj
            read (21,*,ERR=90) (objekt2(m),m=1,numVar)

c           ** call function distanz12 **
            d12=distanz12(objekt1,objekt2,maxVariable,numVar,mdist)           
            if (d12.eq.-999999.999999) then
                close(22,status='DELETE')
                ierr=-3
                goto 120
             endif
            write(22,'(f20.6,2i6)') d12,l,j
2          continue
          l=l+1
          do 3 k=l,numObj
            backspace 21
3          continue
1       continue

       close(21)
       close(22)
       goto 120
90     continue
       close(21)
       close(22,status='DELETE')
       ierr=-4
       goto 120
100    continue
       ierr=-1
       goto 120
110    continue
       ierr=-2
120    continue

       end

c---------------------------------------------------------------

       real function distanz12 (obj1,obj2,maxV,nV,d)

       implicit none
       integer maxVariable
c* Maximum der Variablen 
       parameter(maxVariable=1000)

       integer maxV,nV,d,i,a,b,c
       real obj1(maxV),obj2(maxV),fe1(maxV),fe2(maxV)
       real dist12(maxVariable)
       real mean1,mean2,quadrat1(maxVariable),quadrat2(maxVariable)
       real sd12,sq1,sq2,z_sum(2),s_sum(maxV),p_sum,chisquare

        distanz12=0.
        mean1=0.
        mean2=0.
        sd12=0.
        sq1=0.
        sq2=0.
        a=0
        b=0
        c=0
        chisquare=0.
        z_sum(1)=0.
        z_sum(2)=0.

c*  Distanzmass Euklid 
        if ((d.eq.1) .or. (d.eq.2)) then
            do 1 i=1,nV
              dist12(i)=obj1(i)-obj2(i)
              dist12(i)=dist12(i)*dist12(i)
1            continue

            do 2 i=1,nV
              distanz12=distanz12+dist12(i)
2             continue

            if (d.eq.2) then
                distanz12=sqrt(distanz12)
            endif

c*  Distanzmass Tanimoto-Koeffizient
        else if (d.eq.4) then
            do 5 i=1,nV
              if ((obj1(i).eq.1.).and.(obj2(i).eq.1.)) then 
               a=a+1
              else if ((obj1(i).eq.1.).and.(obj2(i).le.2E-06)) then 
               b=b+1
              else if ((obj1(i).le.2E-06).and.(obj2(i).eq.1.)) then 
               c=c+1
              endif
5             continue
              if(real(a+b+c).le.2E-06) then
                 write(*,*)'Variablen mssen binr codiert sein!'
                 write(*,*)'*                ODER'
                 write(*,*)
     * '* mindestens eine Variable mit Inhalt 1 mu vorhanden sein!'
                 close(22,status='DELETE')
                distanz12=-999999.999999
              else
               distanz12=real(a)/(real(a+b+c))
              endif

c*  Distanzmass  Q-Korrelationskoeffizient
        else if (d.eq.5) then
             do 6 i=1,nV
                mean1=mean1+(obj1(i))/real(nV)
                mean2=mean2+(obj2(i))/real(nV)
6             continue
             do 7 i=1,nV
               dist12(i)=(obj1(i)-mean1)*(obj2(i)-mean2)
               quadrat1(i)=(obj1(i)-mean1)*(obj1(i)-mean1)
               quadrat2(i)=(obj2(i)-mean2)*(obj2(i)-mean2)
7             continue
             do 8 i=1,nV
                sd12=sd12+dist12(i)
                sq1=sq1+quadrat1(i)
                sq2=sq2+quadrat2(i)
8             continue
             distanz12=sd12/sqrt(sq1*sq2)
c*  Distanzmass  Chi-Quadrat
        else if (d.eq.3) then
             do 10 i=1,nV
                 z_sum(1)=z_sum(1)+obj1(i)
                 z_sum(2)=z_sum(2)+obj2(i)
                 s_sum(i)=obj1(i)+obj2(i)
10            continue
              p_sum=z_sum(1)+z_sum(2)
            do 11 i=1,nV
                 fe1(i)=(s_sum(i)*z_sum(1))/p_sum
                 fe2(i)=(s_sum(i)*z_sum(2))/p_sum
11          continue
            do 12 i=1,nV
             if (fe1(i).ne.0) chisquare=chisquare+
     *        (((obj1(i)-fe1(i))*(obj1(i)-fe1(i)))/fe1(i))
             if (fe2(i).ne.0) chisquare=chisquare+
     *        (((obj2(i)-fe2(i))*(obj2(i)-fe2(i)))/fe2(i))
12          continue
            distanz12=sqrt(chisquare)
        endif
       end

C******************************************************************
       subroutine ranking
     *   (inFil,nO,mdist,kfile,dfile,alpha,stress,it,ierr)

       implicit none
       character*255 inFil
       character*255 kfile,dfile
       integer nO,i,j,MaxDis,nD,c1,c2,mdist,it,ierr
       real dis,stress,alpha
       parameter(MaxDis=500000)
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer rank
        real dkl
        real disp
       end structure

       record /einproximity/proximities(MaxDis)


        nD=nO*(nO-1)/2
        open(22,status='OLD',file=inFil,err=110)
        
        do 1 i=1,nD
          read (22,'(f20.6,2i6)',err=115) proximities(i).distanz,
     *     proximities(i).case1,proximities(i).case2
1         continue
        close (22,status='DELETE')
        if (mdist.le.3) then
         do 2 i=1,nD-1
          do 3 j=i+1,nD
          if (proximities(i).distanz.gt.proximities(j).distanz) then
              dis=proximities(i).distanz
              c1=proximities(i).case1
              c2=proximities(i).case2
              proximities(i).distanz=proximities(j).distanz
              proximities(i).case1=proximities(j).case1
              proximities(i).case2=proximities(j).case2
              proximities(j).distanz=dis
              proximities(j).case1=c1
              proximities(j).case2=c2
           endif
3         continue
2        continue  
        endif
        if (mdist.gt.3) then
         do 4 i=1,nD-1
          do 5 j=i+1,nD
          if (proximities(i).distanz.lt.proximities(j).distanz) then
              dis=proximities(i).distanz
              c1=proximities(i).case1
              c2=proximities(i).case2
              proximities(i).distanz=proximities(j).distanz
              proximities(i).case1=proximities(j).case1
              proximities(i).case2=proximities(j).case2
              proximities(j).distanz=dis
              proximities(j).case1=c1
              proximities(j).case2=c2
           endif
5         continue
4        continue  
        endif

        j=1
        proximities(1).rank=1
        do 10 i=2,nD
         if (proximities(i).distanz.eq.proximities(i-1).distanz) then
            proximities(i).rank=j
          else
           j=j+1
           proximities(i).rank=j
          endif
10      continue 

        kfile=inFil(1:index(inFil,'.'))//'coord'
        dfile=inFil(1:index(inFil,'.'))//'dkldis'

        call koord(proximities,nO,nD,kfile,dfile,alpha,stress,it,ierr)
        goto 120

110     continue
        ierr=-1
        goto 120 
115     continue
        ierr=-4
        close (22,status='DELETE')
120     continue
       end

C---------------------------------------------------------------------
       subroutine koord
     *   (proximities,nO,nD,kfile,dfile,alpha,stress,it,ierr)

       implicit none
       integer sd,nO,nD,i,j,MaxDis,MaxObj,hc1,hc2,it,ierr
       real seed1,md,hx1,hx2,stress,ran
       parameter(MaxDis=500000,MaxObj=1000)
       real alpha
       character*255 kfile,dfile

       structure /eincoordinat/
        integer case
        real xk1
        real xk2
       end structure
                
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer rank
        real dkl
        real disp
       end structure

       record /einproximity/proximities(MaxDis)
       record /eincoordinat/coordinates(MaxObj)

       j=nO
       sd=nO
       do 1 i=1,nO
         seed1=ran(sd)
         coordinates(i).case=i 
         coordinates(i).xk1=seed1
         coordinates(j).xk2=seed1
         j=j-1
1      continue

       call edistanz(proximities,coordinates,nD,nO)
       md=9999999.99   
       do 10 i=1,nD
        if (proximities(i).dkl.lt.md) then
         md=proximities(i).dkl
         hc1=proximities(i).case1
         hc2=proximities(i).case2
        endif
10      continue
        hx1=coordinates(proximities(1).case1).xk1
        hx2=coordinates(proximities(1).case1).xk2
        coordinates(proximities(1).case1).xk1=coordinates(hc1).xk1
        coordinates(proximities(1).case1).xk2=coordinates(hc1).xk2
        coordinates(hc1).xk1=hx1
        coordinates(hc1).xk2=hx2
        hx1=coordinates(proximities(1).case2).xk1
        hx2=coordinates(proximities(1).case2).xk2
        coordinates(proximities(1).case2).xk1=coordinates(hc2).xk1
        coordinates(proximities(1).case2).xk2=coordinates(hc2).xk2
        coordinates(hc2).xk1=hx1
        coordinates(hc2).xk2=hx2
       md=0.   
       do 11 i=1,nD
        if (proximities(i).dkl.gt.md) then
         md=proximities(i).dkl
         hc1=proximities(i).case1
         hc2=proximities(i).case2
        endif
11     continue
        hx1=coordinates(proximities(nD).case1).xk1
        hx2=coordinates(proximities(nD).case1).xk2
        coordinates(proximities(nD).case1).xk1=coordinates(hc1).xk1
        coordinates(proximities(nD).case1).xk2=coordinates(hc1).xk2
        coordinates(hc1).xk1=hx1
        coordinates(hc1).xk2=hx2
        hx1=coordinates(proximities(nD).case2).xk1
        hx2=coordinates(proximities(nD).case2).xk2
        coordinates(proximities(nD).case2).xk1=coordinates(hc2).xk1
        coordinates(proximities(nD).case2).xk2=coordinates(hc2).xk2
        coordinates(hc2).xk1=hx1
        coordinates(hc2).xk2=hx2

        call edistanz(proximities,coordinates,nD,nO)
      
        stress=1.0
        it=1

         do while ((stress.gt.0.025).and.(alpha.gt.0.005))         
          call disparity(proximities,nD,nO,stress,alpha)
          call newkoord(proximities,coordinates,nD,nO,alpha)
          call edistanz(proximities,coordinates,nD,nO)
          it=it+1
         end do
        call disparity(proximities,nD,nO,stress,alpha)

        open(24,file=kfile,status='NEW',err=100)
        open(25,file=dfile,status='NEW',err=110)

        do 16 i=1,nO
         write (24,'(i6,a1,f20.6,a1,f20.6)')coordinates(i).case,  
     *   ',',coordinates(i).xk1,',',coordinates(i).xk2
16      continue
        it=it-1
        do 18 i=2,nD
         if ((proximities(i-1).dkl.gt.proximities(i).dkl).and.
     *      (proximities(i-1).disp.eq.0.)) then
            proximities(i-1).disp=proximities(i).disp
         else if ((proximities(i-1).dkl.le.proximities(i).dkl).and.
     *      (proximities(i-1).disp.eq.0.)) then
            proximities(i-1).disp=proximities(i).dkl
          end if
18      continue
        do 20 i=1,nD
         write (25,'(f20.6,a1,f20.6)')proximities(i).dkl,',',
     *        proximities(i).disp
20      continue
        close(24)
        close(25)
        goto 120
100     continue
         ierr=-2
         goto 120
110     continue
         ierr=-3
         close(24,status='DELETE')
120     continue
       end
c-------------------------------------------------------------------
       subroutine edistanz(proximities,coordinates,nD,nO)

       implicit none
       integer nO,nD,i,j,MaxDis,MaxObj,hc1,hc2
       real hxk1,hxk2,hxl1,hxl2
       parameter(MaxDis=500000,MaxObj=1000)

       structure /eincoordinat/
        integer case
        real xk1
        real xk2
       end structure
                
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer rank
        real dkl
        real disp
       end structure

       record /einproximity/proximities(MaxDis)
       record /eincoordinat/coordinates(MaxObj)

      do 5 i=1,nD
            hc1=min(proximities(i).case1,proximities(i).case2)
            hc2=max(proximities(i).case1,proximities(i).case2)         
            do 4 j=1,nO
               if (coordinates(j).case.eq.hc1) then
                 hxk1=coordinates(j).xk1
                 hxk2=coordinates(j).xk2
                endif
               if (coordinates(j).case.eq.hc2) then
                 hxl1=coordinates(j).xk1
                 hxl2=coordinates(j).xk2
                endif
4           continue
           proximities(i).dkl=sqrt((hxk1-hxl1)*(hxk1-hxl1)
     *       +(hxk2-hxl2)*(hxk2-hxl2))
5       continue
       end
C-----------------------------------------------------------------
        subroutine disparity (proximities,nD,nO,stress,alpha)

       implicit none
       integer nO,nD,i,j,MaxDis,MaxObj,hc1,hc2
       real hxk1,hxk2,hxl1,hxl2,dkldisp,qdkl
       real stress,altstress,alpha
       parameter(MaxDis=500000,MaxObj=1000)

                
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer rank
        real dkl
        real disp
       end structure

       record /einproximity/proximities(MaxDis)

        
        do 4 i=2,nD
         if (proximities(i-1).dkl.gt.proximities(i).dkl) then
           proximities(i).disp=
     *      (proximities(i-1).dkl+proximities(i).dkl)/2
          else
              proximities(i).disp=0.
           endif
4        continue
         dkldisp=0
         qdkl=0
         do 5 i=1,nD
           qdkl=qdkl+(proximities(i).dkl*proximities(i).dkl)
5        continue
         do 6 i=2,nD
           if (proximities(i).disp.gt.0) then
             dkldisp=dkldisp+((proximities(i).dkl-proximities(i).disp)*
     *              (proximities(i).dkl-proximities(i).disp)*2)
            endif
6        continue
         altstress=stress
         stress=sqrt(dkldisp/qdkl)
         if (altstress.le.stress) alpha=alpha/2
       end

c--------------------------------------------------------------------

      subroutine newkoord(proximities,coordinates,nD,nO,alpha)

       implicit none
       integer nO,nD,i,j,MaxDis,MaxObj,oc
       real alpha,t1,t2
       parameter(MaxDis=500000,MaxObj=1000)

       structure /eincoordinat/
        integer case
        real xk1
        real xk2
       end structure

       structure /heincoordinat/
        integer case
        real xk1
        real xk2
       end structure
                
       structure /einproximity/
        real distanz
        integer case1
        integer case2
        integer rank
        real dkl
        real disp
       end structure

       record /einproximity/proximities(MaxDis)
       record /eincoordinat/coordinates(MaxObj)
       record /heincoordinat/hcoordinates(MaxObj)

       proximities(nD+1).dkl=proximities(nD).dkl*2
       do 1 i=1,nO
         t1=0
         t2=0
         do 2 j=1,nD
          if ((i.eq.proximities(j).case1).or.
     *     (i.eq.proximities(j).case2)) then
            if (i.eq.proximities(j).case1) oc=proximities(j).case2
            if (i.eq.proximities(j).case2) oc=proximities(j).case1
             if (proximities(j).disp.ne.0) then
                t1=t1+(1-(proximities(j).disp/proximities(j).dkl))*
     *             (coordinates(oc).xk1-coordinates(i).xk1)
                t2=t2+(1-(proximities(j).disp/proximities(j).dkl))*
     *             (coordinates(oc).xk2-coordinates(i).xk2)
              else if ((proximities(j).disp.eq.0).and.
     *         (proximities(j).dkl.gt.proximities(j+1).dkl)) then
                t1=t1+(1-(proximities(j+1).disp/proximities(j).dkl))*
     *             (coordinates(oc).xk1-coordinates(i).xk1)
                t2=t2+(1-(proximities(j+1).disp/proximities(j).dkl))*
     *             (coordinates(oc).xk2-coordinates(i).xk2)
              endif
           endif
2         continue
           hcoordinates(i).case=i
           hcoordinates(i).xk1=coordinates(i).xk1+((alpha/(nO-1))*t1)
           hcoordinates(i).xk2=coordinates(i).xk2+((alpha/(nO-1))*t2)
1        continue
        do 3 i=1,nO
           coordinates(i).xk1= hcoordinates(i).xk1
           coordinates(i).xk2= hcoordinates(i).xk2
3        continue  
       end




